POJ

来源:互联网 发布:双色球缩水软件免费版 编辑:程序博客网 时间:2024/06/10 21:06
N (1 ≤ N ≤ 100) cows, conveniently numbered 1..N, are participating in a programming contest. As we all know, some cows code better than others. Each cow has a certain constant skill rating that is unique among the competitors.


The contest is conducted in several head-to-head rounds, each between two cows. If cow A has a greater skill level than cow B (1 ≤ A ≤ N; 1 ≤ B ≤ N; A ≠ B), then cow A will always beat cow B.


Farmer John is trying to rank the cows by skill level. Given a list the results of M (1 ≤ M ≤ 4,500) two-cow rounds, determine the number of cows whose ranks can be precisely determined from the results. It is guaranteed that the results of the rounds will not be contradictory.


Input
* Line 1: Two space-separated integers: N and M
* Lines 2..M+1: Each line contains two space-separated integers that describe the competitors and results (the first integer, A, is the winner) of a single round of competition: A and B

Output
* Line 1: A single integer representing the number of cows whose ranks can be determined
 

Sample Input
5 5
4 3
4 2
3 2
1 2
2 5
Sample Output

2


题意:给你几组两两确定的关系,然后找出能确定排名的有多少个

思路:要能确定排名,就需要比你大的和比你小的加起来一共是n-1个,我一开始想只用并查集,然后发现只用并查集实现不了,因为并不能确定具体的关系,比你大或者比你小,所以会出问题,然后加拓扑排序的话就麻烦点了,然后看就用Floyd来算,毕竟n<=100,


代码:

#include <cstdio>#include <cmath>#include <iostream>#include <cstring>#include <algorithm>#include <queue>#include <stack>#include <vector>#include <map>#include <numeric>#include <set>#include <string>#include <cctype>#include <sstream>#define INF 0x3f3f3f3f#define lson l, m, rt<<1#define rson m+1, r, rt<<1|1using namespace std;typedef long long LL;typedef pair<LL, LL> P;const int maxn = 1e2 + 5;const int mod = 1e8 + 7;int G[maxn][maxn];int n,m;int main() {    //freopen ("in.txt", "r", stdin);    while (~scanf ("%d%d",&n,&m)){        memset(G,0,sizeof(G));        int u,v;        while (m--){            scanf ("%d%d",&u,&v);            G[u][v]=1;        }        for (int k=1;k<=n;k++){            for (int i=1;i<=n;i++){                for (int j=1;j<=n;j++){                    G[i][j]=(G[i][k]&&G[k][j])||G[i][j];                }            }        }        int ans=0;        for (int i=1;i<=n;i++){            int cnt=0;            for (int j=1;j<=n;j++){                if (i==j) continue;                cnt+=G[i][j];                cnt+=G[j][i];            }            if (cnt==n-1) ans++;        }        printf ("%d\n",ans);    }    return 0;}


原创粉丝点击